<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="20131001" xmlns:xmi="http://www.omg.org/spec/XMI/20131001" xmlns:C_Cpp="http://www.eclipse.org/papyrus/C_Cpp/1" xmlns:Deployment="http://www.eclipse.org/papyrus/Deployment/1" xmlns:ecore="http://www.eclipse.org/emf/2002/Ecore" xmlns:standard="http://www.eclipse.org/uml2/5.0.0/UML/Profile/Standard" xmlns:uml="http://www.eclipse.org/uml2/5.0.0/UML">
  <uml:Model xmi:id="_O6TiIDLUEd26WNosUASSSw" name="ComplexSM">
    <packagedElement xmi:type="uml:Package" xmi:id="_Uu8o0SL0Eeirb_C4HjtHrA" name="deployment">
      <packagedElement xmi:type="uml:Package" xmi:id="_Uu9P4iL0Eeirb_C4HjtHrA" name="ComplexSMDepPlan">
        <packagedElement xmi:type="uml:InstanceSpecification" xmi:id="_KY5NgJbOEeanRKHSrFuDZA" name="mainInstance" classifier="_oqZNUDLaEd2qeKRLMdIx_A"/>
      </packagedElement>
      <profileApplication xmi:id="_OTdTUOSmEeaYxL1QJO8D3g">
        <eAnnotations xmi:id="_OTehcOSmEeaYxL1QJO8D3g" source="http://www.eclipse.org/uml2/2.0.0/UML">
          <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/Deployment/1#/"/>
        </eAnnotations>
        <appliedProfile href="pathmap://DEP_PROFILE/Deployment.profile.uml#_gPDsIBa-EearhdjjJ6cVzQ"/>
      </profileApplication>
    </packagedElement>
    <packagedElement xmi:type="uml:Package" xmi:id="_Uu928SL0Eeirb_C4HjtHrA" name="classes">
      <packagedElement xmi:type="uml:Class" xmi:id="_oqZNUDLaEd2qeKRLMdIx_A" name="ComplexSM" classifierBehavior="_Uu7asCL0Eeirb_C4HjtHrA">
        <ownedAttribute xmi:id="_Ya5_oCkFEeaWptp_P1JVYQ" name="x">
          <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_7wRIABydEduyofBvg4RL2w"/>
        </ownedAttribute>
        <ownedAttribute xmi:id="_Uon-YCL0Eeirb_C4HjtHrA" name="systemState">
          <type xmi:type="uml:Enumeration" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/statemachine.uml#_uYyt0CdFEea3Ob5UfxuCGA"/>
        </ownedAttribute>
        <ownedAttribute xmi:id="_UtAIEiL0Eeirb_C4HjtHrA" name="Junction1">
          <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_7wRIABydEduyofBvg4RL2w"/>
        </ownedAttribute>
        <ownedAttribute xmi:id="_UtG1wCL0Eeirb_C4HjtHrA" name="states" type="_UtAvJCL0Eeirb_C4HjtHrA"/>
        <ownedAttribute xmi:id="_UtKgISL0Eeirb_C4HjtHrA" name="activeStateID" type="_UtAvICL0Eeirb_C4HjtHrA"/>
        <ownedAttribute xmi:id="_UtlW4SL0Eeirb_C4HjtHrA" name="dispatchFlag">
          <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_vAIV4I7PEdySGvm5GN66HA"/>
        </ownedAttribute>
        <ownedAttribute xmi:id="_Ut0AYCL0Eeirb_C4HjtHrA" name="threads">
          <type xmi:type="uml:Class" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/pthread.uml#_ea234NYGEd-CgJIavLpOxQ"/>
        </ownedAttribute>
        <ownedAttribute xmi:id="_Ut78MSL0Eeirb_C4HjtHrA" name="flags">
          <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_vAIV4I7PEdySGvm5GN66HA"/>
        </ownedAttribute>
        <ownedAttribute xmi:id="_UuGUQSL0Eeirb_C4HjtHrA" name="conds">
          <type xmi:type="uml:Class" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/pthread.uml#_-vYZoCa0EeazPcQ6-9hBeQ"/>
        </ownedAttribute>
        <ownedAttribute xmi:id="_UuLz0SL0Eeirb_C4HjtHrA" name="mutexes">
          <type xmi:type="uml:Class" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/pthread.uml#__niwsCa0EeazPcQ6-9hBeQ"/>
        </ownedAttribute>
        <ownedAttribute xmi:id="_UuShgSL0Eeirb_C4HjtHrA" name="threadStructs">
          <type xmi:type="uml:Class" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/statemachine.uml#_4Z1UwCmREearkPe7QerpcQ"/>
        </ownedAttribute>
        <ownedAttribute xmi:id="_Uuk1YCL0Eeirb_C4HjtHrA" name="doActivityTable" type="_UuhyEiL0Eeirb_C4HjtHrA"/>
        <ownedAttribute xmi:id="_UuofwCL0Eeirb_C4HjtHrA" name="timeEventTable" type="_UuhyEiL0Eeirb_C4HjtHrA"/>
        <ownedAttribute xmi:id="_Uuq8ASL0Eeirb_C4HjtHrA" name="timeEventThreads">
          <type xmi:type="uml:Class" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/pthread.uml#_ea234NYGEd-CgJIavLpOxQ"/>
        </ownedAttribute>
        <ownedAttribute xmi:id="_UutYQSL0Eeirb_C4HjtHrA" name="timeEventFlags">
          <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_vAIV4I7PEdySGvm5GN66HA"/>
        </ownedAttribute>
        <ownedAttribute xmi:id="_Uuv0gSL0Eeirb_C4HjtHrA" name="timeEventConds">
          <type xmi:type="uml:Class" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/pthread.uml#_-vYZoCa0EeazPcQ6-9hBeQ"/>
        </ownedAttribute>
        <ownedAttribute xmi:id="_Uuy30SL0Eeirb_C4HjtHrA" name="timeEventMutexes">
          <type xmi:type="uml:Class" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/pthread.uml#__niwsCa0EeazPcQ6-9hBeQ"/>
        </ownedAttribute>
        <ownedAttribute xmi:id="_Uu1UESL0Eeirb_C4HjtHrA" name="timeEventThreadStructs">
          <type xmi:type="uml:Class" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/statemachine.uml#_4Z1UwCmREearkPe7QerpcQ"/>
        </ownedAttribute>
        <ownedAttribute xmi:id="_Uu4XZCL0Eeirb_C4HjtHrA" name="eventQueue">
          <type xmi:type="uml:Class" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/statemachine.uml#_dWxYQD0zEeaQfbTekb55bw"/>
        </ownedAttribute>
        <ownedAttribute xmi:id="_Uu4-cCL0Eeirb_C4HjtHrA" name="currentEvent">
          <type xmi:type="uml:Class" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/statemachine.uml#_MyJIUD0zEeaQfbTekb55bw"/>
        </ownedAttribute>
        <ownedAttribute xmi:id="_Uu7asSL0Eeirb_C4HjtHrA" name="dispatchThread">
          <type xmi:type="uml:Class" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/pthread.uml#_ea234NYGEd-CgJIavLpOxQ"/>
        </ownedAttribute>
        <ownedAttribute xmi:id="_Uu7asiL0Eeirb_C4HjtHrA" name="dispatchStruct">
          <type xmi:type="uml:Class" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/statemachine.uml#_4Z1UwCmREearkPe7QerpcQ"/>
        </ownedAttribute>
        <ownedAttribute xmi:id="_Uu7asyL0Eeirb_C4HjtHrA" name="runToCompletionMutex">
          <type xmi:type="uml:Class" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/pthread.uml#__niwsCa0EeazPcQ6-9hBeQ"/>
        </ownedAttribute>
        <ownedAttribute xmi:id="_Uu7atCL0Eeirb_C4HjtHrA" name="runToCompletionCond">
          <type xmi:type="uml:Class" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/pthread.uml#_-vYZoCa0EeazPcQ6-9hBeQ"/>
        </ownedAttribute>
        <interfaceRealization xmi:id="_YQqH0JYlEd6G9q9hwr11bw" name="realization of ICompute" client="_oqZNUDLaEd2qeKRLMdIx_A" supplier="_cn-H0DLbEd2qeKRLMdIx_A" contract="_cn-H0DLbEd2qeKRLMdIx_A"/>
        <interfaceRealization xmi:id="_VGnYgCgBEeapjr3l63b85A" name="realization of IStart" client="_oqZNUDLaEd2qeKRLMdIx_A">
          <supplier xmi:type="uml:Interface" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/sysinterfaces.uml#_PTWzwCS-Ed-A_I32T0fkaA"/>
          <contract href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/sysinterfaces.uml#_PTWzwCS-Ed-A_I32T0fkaA"/>
        </interfaceRealization>
        <ownedBehavior xmi:type="uml:OpaqueBehavior" xmi:id="_Uu7asCL0Eeirb_C4HjtHrA" name="dispatchEvent" specification="_Uu6zoSL0Eeirb_C4HjtHrA">
          <language>C++</language>
          <body>bool popDeferred = false;
while(true) {
	//run-to-completion: need to have a mutex here
	currentEvent = eventQueue.pop(popDeferred);
	dispatchFlag = true;
	if (currentEvent != NULL) {
		COMPLEXSM_GET_CONTROL
		switch(currentEvent->eventID) {
			case TE_VALUE_50_UNIT_MS__ID: {
				processTE_value_50_unit_ms_();
				break;
			}
			case TE_VALUE_500_UNIT_MS__ID: {
				processTE_value_500_unit_ms_();
				break;
			}
			case TE_VALUE_25_UNIT_MS__ID: {
				processTE_value_25_unit_ms_();
				break;
			}
				case COMPLETIONEVENT_ID: {
					processCompletionEvent();
					break;
				}
		}
		if (systemState == statemachine::EVENT_DEFERRED) {
			eventQueue.saveDeferred(*currentEvent);
		}
		popDeferred = (systemState != statemachine::EVENT_DEFERRED);
		systemState = statemachine::IDLE;
		COMPLEXSM_RELEASE_CONTROL
	}
	usleep(100);
}</body>
        </ownedBehavior>
        <ownedBehavior xmi:type="uml:StateMachine" xmi:id="_y7KWsOYXEeCBL_IbXY9ofw" name="SMSimple">
          <region xmi:id="_0Lv00OYXEeCBL_IbXY9ofw" name="Region0">
            <transition xmi:id="_CLBzIOYYEeCBL_IbXY9ofw" name="Transition0" source="_1UVNgOYXEeCBL_IbXY9ofw" target="_53E_8OYXEeCBL_IbXY9ofw"/>
            <transition xmi:id="_Doi6AOYYEeCBL_IbXY9ofw" name="Transition1" source="_53E_8OYXEeCBL_IbXY9ofw" target="_7_1cMOYXEeCBL_IbXY9ofw">
              <trigger xmi:id="_rHpXoOtoEeCjb9i0gG4phA" event="_rHoJgOtoEeCjb9i0gG4phA"/>
            </transition>
            <transition xmi:id="_OH_UYOYYEeCBL_IbXY9ofw" name="Transition2" source="_7_1cMOYXEeCBL_IbXY9ofw" target="_53E_8OYXEeCBL_IbXY9ofw">
              <effect xmi:type="uml:OpaqueBehavior" xmi:id="_CAWpgSSoEeG6GJ4vU06VYQ" name="mult" isAbstract="true">
                <language>C/C++</language>
                <body>mult(3,5);&#xD;
std::cout &lt;&lt;&quot;From State1 to State0 \n&quot;;</body>
              </effect>
              <trigger xmi:id="_-aQtACaeEeG4fZdVXNtoOQ" event="_-PMFcCaeEeG4fZdVXNtoOQ"/>
            </transition>
            <transition xmi:id="_mJvoUOtqEeCzSsOGmQH2aA" name="Transition3" source="_53E_8OYXEeCBL_IbXY9ofw" target="_7_1cMOYXEeCBL_IbXY9ofw">
              <trigger xmi:id="_8WepQHoDEeOA64V_YLapaA" event="_8WeCMHoDEeOA64V_YLapaA"/>
            </transition>
            <transition xmi:id="_rdKgsCjmEeaJJusTB1aIbg" source="_53E_8OYXEeCBL_IbXY9ofw" target="_owZYcCjmEeaJJusTB1aIbg">
              <effect xmi:type="uml:OpaqueBehavior" xmi:id="_-EnkACjmEeaJJusTB1aIbg" isAbstract="true">
                <language>C++</language>
                <body>cout &lt;&lt; &quot;From State 0 to State 2&quot; &lt;&lt; endl;</body>
              </effect>
              <trigger xmi:id="_4eMuECjmEeaJJusTB1aIbg" event="_4WSIMCjmEeaJJusTB1aIbg"/>
            </transition>
            <transition xmi:id="_BO7j4CjnEeaJJusTB1aIbg" source="_owZYcCjmEeaJJusTB1aIbg" target="__9lQwCjmEeaJJusTB1aIbg">
              <effect xmi:type="uml:OpaqueBehavior" xmi:id="_F9mScCjnEeaJJusTB1aIbg">
                <language>C++</language>
                <body>x = 6;&#xD;
std::cout &lt;&lt;&quot;From State 2 to Junction1\n&quot;;&#xD;
</body>
              </effect>
              <trigger xmi:id="_GlK94CjpEeaJJusTB1aIbg" event="_-PMFcCaeEeG4fZdVXNtoOQ"/>
            </transition>
            <transition xmi:id="_G1QTMCjnEeaJJusTB1aIbg" source="__9lQwCjmEeaJJusTB1aIbg" target="_53E_8OYXEeCBL_IbXY9ofw"/>
            <transition xmi:id="_HnKRQCjnEeaJJusTB1aIbg" guard="_KB4nQCjnEeaJJusTB1aIbg" source="__9lQwCjmEeaJJusTB1aIbg" target="_w-8yoCkEEeaWptp_P1JVYQ">
              <ownedRule xmi:id="_KB4nQCjnEeaJJusTB1aIbg">
                <specification xmi:type="uml:OpaqueExpression" xmi:id="_KB4nQSjnEeaJJusTB1aIbg">
                  <language>C++</language>
                  <body>x == 5</body>
                </specification>
              </ownedRule>
              <effect xmi:type="uml:OpaqueBehavior" xmi:id="_QlLVICjnEeaJJusTB1aIbg" isAbstract="true">
                <language>C++</language>
                <body>cout &lt;&lt; &quot;From Junction1 to Shallow history&quot; &lt;&lt; endl;</body>
              </effect>
            </transition>
            <subvertex xmi:type="uml:Pseudostate" xmi:id="_1UVNgOYXEeCBL_IbXY9ofw" name="Initial0"/>
            <subvertex xmi:type="uml:State" xmi:id="_53E_8OYXEeCBL_IbXY9ofw" name="State0"/>
            <subvertex xmi:type="uml:State" xmi:id="_7_1cMOYXEeCBL_IbXY9ofw" name="State1"/>
            <subvertex xmi:type="uml:State" xmi:id="_owZYcCjmEeaJJusTB1aIbg" name="State2">
              <entry xmi:type="uml:OpaqueBehavior" xmi:id="_hGRNQCkFEeaWptp_P1JVYQ">
                <language>C++</language>
                <body>x = 5;</body>
              </entry>
            </subvertex>
            <subvertex xmi:type="uml:Pseudostate" xmi:id="__9lQwCjmEeaJJusTB1aIbg" name="Junction1" kind="junction"/>
            <subvertex xmi:type="uml:State" xmi:id="_mxZZgCkEEeaWptp_P1JVYQ" name="State3">
              <region xmi:id="_pXD0MCkEEeaWptp_P1JVYQ" name="Region1">
                <transition xmi:id="_zRtfcCkEEeaWptp_P1JVYQ" source="_w-8yoCkEEeaWptp_P1JVYQ" target="_pXM-ICkEEeaWptp_P1JVYQ">
                  <effect xmi:type="uml:OpaqueBehavior" xmi:id="_7hUlMCkEEeaWptp_P1JVYQ" isAbstract="true">
                    <language>C++</language>
                    <body>cout &lt;&lt; &quot;From Shallow history to State 3_1&quot; &lt;&lt; endl;</body>
                  </effect>
                </transition>
                <transition xmi:id="__pc4MCkEEeaWptp_P1JVYQ" source="_pXM-ICkEEeaWptp_P1JVYQ" target="_-AIxACkEEeaWptp_P1JVYQ">
                  <effect xmi:type="uml:OpaqueBehavior" xmi:id="_Im4tQCkFEeaWptp_P1JVYQ" isAbstract="true">
                    <language>C++</language>
                    <body>cout &lt;&lt; &quot;From State 3_1 to State 3_2&quot; &lt;&lt; endl;</body>
                  </effect>
                  <trigger xmi:id="_D0f8UCkFEeaWptp_P1JVYQ" event="_-PMFcCaeEeG4fZdVXNtoOQ"/>
                </transition>
                <transition xmi:id="_JPEuoCkFEeaWptp_P1JVYQ" source="_-AIxACkEEeaWptp_P1JVYQ" target="_7_1cMOYXEeCBL_IbXY9ofw">
                  <effect xmi:type="uml:OpaqueBehavior" xmi:id="_QHO5QCkFEeaWptp_P1JVYQ" isAbstract="true">
                    <language>C++</language>
                    <body>cout &lt;&lt; &quot;From State 5 to State 1&quot; &lt;&lt; endl;</body>
                  </effect>
                  <trigger xmi:id="_NO0hsCkFEeaWptp_P1JVYQ" event="_-PMFcCaeEeG4fZdVXNtoOQ"/>
                </transition>
                <subvertex xmi:type="uml:Pseudostate" xmi:id="_w-8yoCkEEeaWptp_P1JVYQ" name="ShallowHistory1" kind="shallowHistory"/>
                <subvertex xmi:type="uml:State" xmi:id="_pXM-ICkEEeaWptp_P1JVYQ" name="State3_1"/>
                <subvertex xmi:type="uml:State" xmi:id="_-AIxACkEEeaWptp_P1JVYQ" name="State3_2"/>
              </region>
            </subvertex>
          </region>
        </ownedBehavior>
        <ownedBehavior xmi:type="uml:OpaqueBehavior" xmi:id="_ML-4AKI5Ed6FqJCjEUrkqQ" name="add" specification="_TbIjUJYlEd6G9q9hwr11bw">
          <ownedParameter xmi:id="_etAhAC1REea25uwDpRQuxg" name="a">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8heigBydEduyofBvg4RL2w"/>
            <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_etAhAS1REea25uwDpRQuxg" value="1"/>
            <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_etAhAi1REea25uwDpRQuxg" value="1"/>
          </ownedParameter>
          <ownedParameter xmi:id="_etAhAy1REea25uwDpRQuxg" name="b">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8heigBydEduyofBvg4RL2w"/>
            <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_etBIEC1REea25uwDpRQuxg" value="1"/>
            <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_etBIES1REea25uwDpRQuxg" value="1"/>
          </ownedParameter>
          <ownedParameter xmi:id="_etBIEi1REea25uwDpRQuxg" name="res" direction="return">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8heigBydEduyofBvg4RL2w"/>
            <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_etBIEy1REea25uwDpRQuxg" value="1"/>
            <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_etBvIC1REea25uwDpRQuxg" value="1"/>
          </ownedParameter>
          <language>C/C++</language>
          <body>this->processCE_CServer_impl_add(a, b);
// original method code
cout &lt;&lt; &quot;a=&quot; &lt;&lt; a &lt;&lt; &quot; b=&quot; &lt;&lt; b &lt;&lt; &quot; a+b=&quot; &lt;&lt; a+b &lt;&lt; endl;
return a+b;</body>
        </ownedBehavior>
        <ownedBehavior xmi:type="uml:OpaqueBehavior" xmi:id="_qxjWINnmEd2_cstbO2Uzgg" name="mult" specification="_4ZEZwHecEd6r18stFZxmFQ">
          <ownedParameter xmi:id="_es-r0C1REea25uwDpRQuxg" name="a">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8heigBydEduyofBvg4RL2w"/>
            <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_es-r0S1REea25uwDpRQuxg" value="1"/>
            <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_es-r0i1REea25uwDpRQuxg" value="1"/>
          </ownedParameter>
          <ownedParameter xmi:id="_es_S4C1REea25uwDpRQuxg" name="b">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8heigBydEduyofBvg4RL2w"/>
            <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_es_S4S1REea25uwDpRQuxg" value="1"/>
            <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_es_S4i1REea25uwDpRQuxg" value="1"/>
          </ownedParameter>
          <ownedParameter xmi:id="_es_58C1REea25uwDpRQuxg" name="res" direction="return">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8heigBydEduyofBvg4RL2w"/>
            <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_es_58S1REea25uwDpRQuxg" value="1"/>
            <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_es_58i1REea25uwDpRQuxg" value="1"/>
          </ownedParameter>
          <language>C/C++</language>
          <body>cout &lt;&lt; &quot;a=&quot; &lt;&lt; a &lt;&lt; &quot; b=&quot; &lt;&lt; b &lt;&lt; &quot; a*b=&quot; &lt;&lt; a*b &lt;&lt; endl;
return a*b;</body>
        </ownedBehavior>
        <ownedBehavior xmi:type="uml:OpaqueBehavior" xmi:id="_YNCW4CgBEeapjr3l63b85A" name="run" specification="_VGsRACgBEeapjr3l63b85A">
          <language>C/C++</language>
          <body>cout &lt;&lt; &quot;call add (2, 3);&quot; &lt;&lt; endl;
cout &lt;&lt; &quot;result: &quot; &lt;&lt; add (2, 3) &lt;&lt; endl;
cout &lt;&lt; &quot;sleeping for 15 seconds (statemachine remains active);&quot; &lt;&lt; endl;
sleep(15);
</body>
        </ownedBehavior>
        <ownedBehavior xmi:type="uml:OpaqueBehavior" xmi:id="_UtR04CL0Eeirb_C4HjtHrA" name="SMSimple_Region0_Enter" specification="_UtRN0CL0Eeirb_C4HjtHrA">
          <language>C++</language>
          <body>switch(enter_mode) {
	case SMSIMPLE_REGION0_DEFAULT:
		activeStateID = STATE0_ID;
		
		setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_50_UNIT_MS__ID), statemachine::TF_TIME_EVENT, true);
				setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_25_UNIT_MS__ID), statemachine::TF_TIME_EVENT, true);
		
		//TODO: set systemState to EVENT_CONSUMED
		break;
	case SMSIMPLE_REGION0_STATE1:
		activeStateID = STATE1_ID;
		//starting the counters for time events
		setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_500_UNIT_MS__ID), statemachine::TF_TIME_EVENT, true);
		//TODO: set systemState to EVENT_CONSUMED
		break;
}</body>
        </ownedBehavior>
        <ownedBehavior xmi:type="uml:OpaqueBehavior" xmi:id="_UtWtYCL0Eeirb_C4HjtHrA" name="State3_Region1_Enter" specification="_UtSb8CL0Eeirb_C4HjtHrA">
          <language>C++</language>
          <body>switch(enter_mode) {
	case STATE3_REGION1_SHALLOWHISTORY1: 
		unsigned int loc_ActiveId;
		if (states[STATE3_ID].previousStates[0] != STATE_MAX) {
			loc_ActiveId = states[STATE3_ID].previousStates[0];
		} else {
			//for the first time, the history should be initialized
			cout &lt;&lt; &quot;From Shallow history to State 3_1&quot; &lt;&lt; endl;
			loc_ActiveId = STATE3_1_ID;
		}
		states[STATE3_ID].actives[0] = loc_ActiveId;
			(this->*states[loc_ActiveId].entry)();
			if (STATE3_1_ID == loc_ActiveId) {
				setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_500_UNIT_MS__ID), statemachine::TF_TIME_EVENT, true);
			} else 
			if (STATE3_2_ID == loc_ActiveId) {
				setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_500_UNIT_MS__ID), statemachine::TF_TIME_EVENT, true);
			}
			setFlag(loc_ActiveId, statemachine::TF_DO_ACTIVITY, true);
		//TODO: set systemState to EVENT_CONSUMED
		break;
}</body>
        </ownedBehavior>
        <ownedBehavior xmi:type="uml:OpaqueBehavior" xmi:id="_UtX7gSL0Eeirb_C4HjtHrA" name="State3_Region1_Exit" specification="_UtX7gCL0Eeirb_C4HjtHrA">
          <language>C++</language>
          <body>//exiting region Region1
if (states[STATE3_ID].actives[0] != STATE_MAX) {
	//signal to exit the doActivity of sub-state of State3
	setFlag(states[STATE3_ID].actives[0], statemachine::TF_DO_ACTIVITY, false);
	if (STATE3_1_ID == states[STATE3_ID].actives[0]) {
		setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_500_UNIT_MS__ID), statemachine::TF_TIME_EVENT, false);
	} else 
	if (STATE3_2_ID == states[STATE3_ID].actives[0]) {
		setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_500_UNIT_MS__ID), statemachine::TF_TIME_EVENT, false);
	}
	//exit action of sub-state of State3
	(this->*states[states[STATE3_ID].actives[0]].exit)();
	//save history region Region1 of state State3
	states[STATE3_ID].previousStates[0] = states[STATE3_ID].actives[0];
	//set active sub-state of State3 to STATE_MAX meaning NULL
	states[STATE3_ID].actives[0] = STATE_MAX;
}</body>
        </ownedBehavior>
        <ownedBehavior xmi:type="uml:OpaqueBehavior" xmi:id="_UtiTkSL0Eeirb_C4HjtHrA" name="ComplexSM" specification="_UtYikCL0Eeirb_C4HjtHrA">
          <language>C++</language>
          <body>startBehavior();</body>
        </ownedBehavior>
        <ownedBehavior xmi:type="uml:OpaqueBehavior" xmi:id="_UtlW4CL0Eeirb_C4HjtHrA" name="startBehavior" specification="_Uti6oCL0Eeirb_C4HjtHrA">
          <language>C++</language>
          <body>systemState = statemachine::IDLE;
doActivityTable[STATE0_ID] =  states[STATE0_ID].doActivity;
doActivityTable[STATE1_ID] =  states[STATE1_ID].doActivity;
states[STATE2_ID].entry = &amp;ComplexSM::State2_entry;
doActivityTable[STATE2_ID] =  states[STATE2_ID].doActivity;
doActivityTable[STATE3_ID] =  states[STATE3_ID].doActivity;
doActivityTable[STATE3_1_ID] =  states[STATE3_1_ID].doActivity;
doActivityTable[STATE3_2_ID] =  states[STATE3_2_ID].doActivity;

// initialize all threads, the threads wait until the associated flag is set
for(int i = 0; i &lt; (int) STATE_MAX; i++) {
	if (states[i].doActivity != &amp;ComplexSM::doActivity_dft) {
		threadStructs[i].id = i;
		threadStructs[i].ptr = this;
		threadStructs[i].func_type = statemachine::TF_DO_ACTIVITY;
		mutexes[i] = PTHREAD_MUTEX_INITIALIZER;
		conds[i] = PTHREAD_COND_INITIALIZER;
		pthread_create(&amp;threads[i], NULL, &amp;ComplexSM::thread_func_wrapper, &amp;threadStructs[i]);
	}
}

timeEventThreadStructs[COMPLEXSM_TE_INDEX(TE_VALUE_50_UNIT_MS__ID)].duration = 50;
timeEventThreadStructs[COMPLEXSM_TE_INDEX(TE_VALUE_500_UNIT_MS__ID)].duration = 500;
timeEventThreadStructs[COMPLEXSM_TE_INDEX(TE_VALUE_25_UNIT_MS__ID)].duration = 25;
for(int i = COMPLEXSM_TIME_EVENT_LOWER_BOUND; i &lt; 3; i++) {
	timeEventThreadStructs[COMPLEXSM_TE_INDEX(i)].id = i;
	timeEventThreadStructs[COMPLEXSM_TE_INDEX(i)].ptr = this;
	timeEventThreadStructs[COMPLEXSM_TE_INDEX(i)].func_type = statemachine::TF_TIME_EVENT;
	timeEventMutexes[COMPLEXSM_TE_INDEX(i)] = PTHREAD_MUTEX_INITIALIZER;
	timeEventConds[COMPLEXSM_TE_INDEX(i)] = PTHREAD_COND_INITIALIZER;
	pthread_create(&amp;timeEventThreads[COMPLEXSM_TE_INDEX(i)], NULL, &amp;ComplexSM::thread_func_wrapper, &amp;timeEventThreadStructs[COMPLEXSM_TE_INDEX(i)]);
	while(timeEventFlags[COMPLEXSM_TE_INDEX(i)]) {}
}



runToCompletionMutex = PTHREAD_MUTEX_INITIALIZER;
runToCompletionCond = PTHREAD_COND_INITIALIZER;

dispatchStruct = statemachine::StructForThread_t(this, 0, 0, statemachine::TF_STATE_MACHINE_TYPE, 0);
ComplexSM_THREAD_CREATE(dispatchThread, dispatchStruct)
while(!dispatchFlag) {}


//initialze root active state
//execute initial effect
SMSimple_Region0_Enter(SMSIMPLE_REGION0_DEFAULT);
</body>
        </ownedBehavior>
        <ownedBehavior xmi:type="uml:OpaqueBehavior" xmi:id="_Utl98CL0Eeirb_C4HjtHrA" name="processTE_value_50_unit_ms_" specification="_UtlW4iL0Eeirb_C4HjtHrA">
          <language>C++</language>
          <body>systemState = statemachine::EVENT_PROCESSING;
if (systemState == statemachine::EVENT_PROCESSING) {
	switch(activeStateID) {
		case STATE0_ID: 
			//from State0 to State1
			if (true) {
			setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_50_UNIT_MS__ID), statemachine::TF_TIME_EVENT, false);
					setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_25_UNIT_MS__ID), statemachine::TF_TIME_EVENT, false);
			activeStateID = STATE1_ID;
			//starting the counters for time events
			setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_500_UNIT_MS__ID), statemachine::TF_TIME_EVENT, true);
			systemState = statemachine::EVENT_CONSUMED;
			}
			break;
		default:
			//do nothing
			break;
	}
}
</body>
        </ownedBehavior>
        <ownedBehavior xmi:type="uml:OpaqueBehavior" xmi:id="_UtvH4CL0Eeirb_C4HjtHrA" name="processTE_value_500_unit_ms_" specification="_Utl98SL0Eeirb_C4HjtHrA">
          <language>C++</language>
          <body>systemState = statemachine::EVENT_PROCESSING;
if (states[STATE3_ID].actives[0] == STATE3_1_ID) {
	//from State3_1 to State3_2
	if (true) {
	setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_500_UNIT_MS__ID), statemachine::TF_TIME_EVENT, false);
	cout &lt;&lt; &quot;From State 3_1 to State 3_2&quot; &lt;&lt; endl;
	states[STATE3_ID].actives[0] = STATE3_2_ID;
	//starting the counters for time events
	setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_500_UNIT_MS__ID), statemachine::TF_TIME_EVENT, true);
	systemState = statemachine::EVENT_CONSUMED;
	}
} else 
if (states[STATE3_ID].actives[0] == STATE3_2_ID) {
	//from State3_2 to State1
	if (true) {
	State3_Region1_Exit();
	cout &lt;&lt; &quot;From State 5 to State 1&quot; &lt;&lt; endl;
	activeStateID = STATE1_ID;
	//starting the counters for time events
	setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_500_UNIT_MS__ID), statemachine::TF_TIME_EVENT, true);
	systemState = statemachine::EVENT_CONSUMED;
	}
}
if (systemState == statemachine::EVENT_PROCESSING) {
	switch(activeStateID) {
		case STATE1_ID: 
			//from State1 to State0
			if (true) {
			setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_500_UNIT_MS__ID), statemachine::TF_TIME_EVENT, false);
			mult(3,5);
			std::cout &lt;&lt;&quot;From State1 to State0 \n&quot;;
			activeStateID = STATE0_ID;
			//starting the counters for time events
			setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_50_UNIT_MS__ID), statemachine::TF_TIME_EVENT, true);
					setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_25_UNIT_MS__ID), statemachine::TF_TIME_EVENT, true);
			systemState = statemachine::EVENT_CONSUMED;
			}
			break;
		case STATE2_ID: 
			//from State2 to Junction1
			if (true) {
				Junction1 = 0;
				if (x == 5) {
					Junction1 = 1;
				}
				setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_500_UNIT_MS__ID), statemachine::TF_TIME_EVENT, false);
				x = 6;
				std::cout &lt;&lt;&quot;From State 2 to Junction1\n&quot;;
				if (Junction1 == 0) {
					activeStateID = STATE0_ID;
					//starting the counters for time events
					setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_50_UNIT_MS__ID), statemachine::TF_TIME_EVENT, true);
							setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_25_UNIT_MS__ID), statemachine::TF_TIME_EVENT, true);
				} else 
				if (Junction1 == 1) {
					cout &lt;&lt; &quot;From Junction1 to Shallow history&quot; &lt;&lt; endl;
					activeStateID = STATE3_ID;
					//starting the counters for time events
					State3_Region1_Enter(STATE3_REGION1_SHALLOWHISTORY1);
				}
			systemState = statemachine::EVENT_CONSUMED;
			}
			break;
		default:
			//do nothing
			break;
	}
}
</body>
        </ownedBehavior>
        <ownedBehavior xmi:type="uml:OpaqueBehavior" xmi:id="_UtvH4iL0Eeirb_C4HjtHrA" name="processCE_CServer_impl_add" specification="_UtvH4SL0Eeirb_C4HjtHrA">
          <language>C++</language>
          <body>COMPLEXSM_GET_CONTROL
systemState = statemachine::EVENT_PROCESSING;
if (systemState == statemachine::EVENT_PROCESSING) {
	switch(activeStateID) {
		case STATE0_ID: 
			//from State0 to State1
			if (true) {
			setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_50_UNIT_MS__ID), statemachine::TF_TIME_EVENT, false);
					setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_25_UNIT_MS__ID), statemachine::TF_TIME_EVENT, false);
			activeStateID = STATE1_ID;
			//starting the counters for time events
			setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_500_UNIT_MS__ID), statemachine::TF_TIME_EVENT, true);
			systemState = statemachine::EVENT_CONSUMED;
			}
			break;
		default:
			//do nothing
			break;
	}
}
COMPLEXSM_RELEASE_CONTROL
</body>
        </ownedBehavior>
        <ownedBehavior xmi:type="uml:OpaqueBehavior" xmi:id="_UtyLMCL0Eeirb_C4HjtHrA" name="processTE_value_25_unit_ms_" specification="_UtxkISL0Eeirb_C4HjtHrA">
          <language>C++</language>
          <body>systemState = statemachine::EVENT_PROCESSING;
if (systemState == statemachine::EVENT_PROCESSING) {
	switch(activeStateID) {
		case STATE0_ID: 
			//from State0 to State2
			if (true) {
			setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_50_UNIT_MS__ID), statemachine::TF_TIME_EVENT, false);
					setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_25_UNIT_MS__ID), statemachine::TF_TIME_EVENT, false);
			cout &lt;&lt; &quot;From State 0 to State 2&quot; &lt;&lt; endl;
			activeStateID = STATE2_ID;
			(this->*states[STATE2_ID].entry)();
			//starting the counters for time events
			setFlag(COMPLEXSM_TE_INDEX(TE_VALUE_500_UNIT_MS__ID), statemachine::TF_TIME_EVENT, true);
			systemState = statemachine::EVENT_CONSUMED;
			}
			break;
		default:
			//do nothing
			break;
	}
}
</body>
        </ownedBehavior>
        <ownedBehavior xmi:type="uml:OpaqueBehavior" xmi:id="_UtyyQCL0Eeirb_C4HjtHrA" name="processCompletionEvent" specification="_UtyLMSL0Eeirb_C4HjtHrA">
          <language>C++</language>
          <body>systemState = statemachine::EVENT_PROCESSING;
</body>
        </ownedBehavior>
        <ownedBehavior xmi:type="uml:OpaqueBehavior" xmi:id="_UtzZUCL0Eeirb_C4HjtHrA" name="State2_entry" specification="_UtyyRCL0Eeirb_C4HjtHrA">
          <language>C++</language>
          <body>x = 5;</body>
        </ownedBehavior>
        <ownedBehavior xmi:type="uml:OpaqueBehavior" xmi:id="_UuhyESL0Eeirb_C4HjtHrA" name="thread_func_wrapper" specification="_UuZPMSL0Eeirb_C4HjtHrA">
          <language>C++</language>
          <body>statemachine::StructForThread_t* cptr = (statemachine::StructForThread_t*)data;
ComplexSM* ptr = (ComplexSM*) cptr->ptr;
switch(cptr->func_type) {
	case statemachine::TF_TIME_EVENT:
		ptr->listenTimeEvent(COMPLEXSM_TE_INDEX(cptr->id), cptr->duration);
		break;
		case statemachine::TF_STATE_MACHINE_TYPE:
			ptr->dispatchEvent();
			break;
}
return NULL;</body>
        </ownedBehavior>
        <ownedBehavior xmi:type="uml:OpaqueBehavior" xmi:id="_UunRoyL0Eeirb_C4HjtHrA" name="doCallActivity" specification="_UunRoSL0Eeirb_C4HjtHrA">
          <language>C++</language>
          <body>flags[id] = false;
while(true) {
	pthread_mutex_lock(&amp;mutexes[id]);
	while(!flags[id]) {
		pthread_cond_wait(&amp;conds[id], &amp;mutexes[id]);
	}
	(this->*doActivityTable[id])();
	bool commitEvent = false;
	if (flags[id]) {
		commitEvent = true;
		flags[id] = false;
	}
	pthread_cond_signal(&amp;conds[id]);
	pthread_mutex_unlock(&amp;mutexes[id]);
}</body>
        </ownedBehavior>
        <ownedBehavior xmi:type="uml:OpaqueBehavior" xmi:id="_Uun4tCL0Eeirb_C4HjtHrA" name="setFlag" specification="_Uun4sCL0Eeirb_C4HjtHrA">
          <language>C++</language>
          <body>//value = true => start activity
//value = false => stop activity
if (func_type == statemachine::TF_TIME_EVENT) {
	pthread_mutex_lock(&amp;timeEventMutexes[COMPLEXSM_TE_INDEX(id)]);
	timeEventFlags[COMPLEXSM_TE_INDEX(id)] = value;
	pthread_cond_signal(&amp;timeEventConds[COMPLEXSM_TE_INDEX(id)]);
	pthread_mutex_unlock(&amp;timeEventMutexes[COMPLEXSM_TE_INDEX(id)]);
	return;
}
if (func_type == statemachine::TF_DO_ACTIVITY) {
}
</body>
        </ownedBehavior>
        <ownedBehavior xmi:type="uml:OpaqueBehavior" xmi:id="_Uu4XYyL0Eeirb_C4HjtHrA" name="listenTimeEvent" specification="_Uu4XYCL0Eeirb_C4HjtHrA">
          <language>C++</language>
          <body>struct timeval tv;
struct timespec ts;
int timedWaitResult;
while(true) {
	pthread_mutex_lock(&amp;timeEventMutexes[id]);
	while(!timeEventFlags[id]) {
		pthread_cond_wait(&amp;timeEventConds[id], &amp;timeEventMutexes[id]);
	}
	
	gettimeofday(&amp;tv, NULL);
	ts.tv_sec = time(NULL) + duration / 1000;
	ts.tv_nsec = tv.tv_usec * 1000 + 1000 * 1000 * (duration % 1000);
	ts.tv_sec += ts.tv_nsec / (1000 * 1000 * 1000);
	ts.tv_nsec %= (1000 * 1000 * 1000);
	
	timedWaitResult = pthread_cond_timedwait(&amp;timeEventConds[id], &amp;timeEventMutexes[id], &amp;ts);
	
  	bool commitEvent = false;
  	if (timedWaitResult != 0) {
  		//timeout
  		commitEvent = true;
  	}
	timeEventFlags[id] = false;
	pthread_cond_signal(&amp;timeEventConds[id]);
	pthread_mutex_unlock(&amp;timeEventMutexes[id]);
	if (commitEvent) {
		//the state does not change, push time event to the queue
		eventQueue.push(statemachine::PRIORITY_2, NULL, id, statemachine::TIME_EVENT, id);
	}
}</body>
        </ownedBehavior>
        <ownedOperation xmi:id="_Uu6zoSL0Eeirb_C4HjtHrA" name="dispatchEvent" method="_Uu7asCL0Eeirb_C4HjtHrA"/>
        <ownedOperation xmi:id="_TbIjUJYlEd6G9q9hwr11bw" name="add" method="_ML-4AKI5Ed6FqJCjEUrkqQ">
          <ownedParameter xmi:id="_espUoC1REea25uwDpRQuxg" name="a">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8heigBydEduyofBvg4RL2w"/>
            <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_esrJ0C1REea25uwDpRQuxg" value="1"/>
            <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_esrJ0S1REea25uwDpRQuxg" value="1"/>
          </ownedParameter>
          <ownedParameter xmi:id="_esrJ0i1REea25uwDpRQuxg" name="b">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8heigBydEduyofBvg4RL2w"/>
            <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_ess_AC1REea25uwDpRQuxg" value="1"/>
            <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_ess_AS1REea25uwDpRQuxg" value="1"/>
          </ownedParameter>
          <ownedParameter xmi:id="_ess_Ai1REea25uwDpRQuxg" name="res" direction="return">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8heigBydEduyofBvg4RL2w"/>
            <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_esu0MC1REea25uwDpRQuxg" value="1"/>
            <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_esu0MS1REea25uwDpRQuxg" value="1"/>
          </ownedParameter>
        </ownedOperation>
        <ownedOperation xmi:id="_4ZEZwHecEd6r18stFZxmFQ" name="mult" method="_qxjWINnmEd2_cstbO2Uzgg">
          <ownedParameter xmi:id="_es5MQC1REea25uwDpRQuxg" name="a">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8heigBydEduyofBvg4RL2w"/>
            <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_es6aYC1REea25uwDpRQuxg" value="1"/>
            <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_es6aYS1REea25uwDpRQuxg" value="1"/>
          </ownedParameter>
          <ownedParameter xmi:id="_es6aYi1REea25uwDpRQuxg" name="b">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8heigBydEduyofBvg4RL2w"/>
            <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_es8PkC1REea25uwDpRQuxg" value="1"/>
            <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_es8PkS1REea25uwDpRQuxg" value="1"/>
          </ownedParameter>
          <ownedParameter xmi:id="_es82oC1REea25uwDpRQuxg" name="res" direction="return">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8heigBydEduyofBvg4RL2w"/>
            <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_es9dsC1REea25uwDpRQuxg" value="1"/>
            <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_es9dsS1REea25uwDpRQuxg" value="1"/>
          </ownedParameter>
        </ownedOperation>
        <ownedOperation xmi:id="_VGsRACgBEeapjr3l63b85A" name="run" method="_YNCW4CgBEeapjr3l63b85A"/>
        <ownedOperation xmi:id="_UtRN0CL0Eeirb_C4HjtHrA" name="SMSimple_Region0_Enter" method="_UtR04CL0Eeirb_C4HjtHrA">
          <ownedParameter xmi:id="_UtRN0SL0Eeirb_C4HjtHrA" name="enter_mode">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_5lVhgBydEduyofBvg4RL2w"/>
          </ownedParameter>
        </ownedOperation>
        <ownedOperation xmi:id="_UtSb8CL0Eeirb_C4HjtHrA" name="State3_Region1_Enter" method="_UtWtYCL0Eeirb_C4HjtHrA">
          <ownedParameter xmi:id="_UtSb8SL0Eeirb_C4HjtHrA" name="enter_mode">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_5lVhgBydEduyofBvg4RL2w"/>
          </ownedParameter>
        </ownedOperation>
        <ownedOperation xmi:id="_UtX7gCL0Eeirb_C4HjtHrA" name="State3_Region1_Exit" method="_UtX7gSL0Eeirb_C4HjtHrA"/>
        <ownedOperation xmi:id="_UtYikCL0Eeirb_C4HjtHrA" name="ComplexSM" method="_UtiTkSL0Eeirb_C4HjtHrA"/>
        <ownedOperation xmi:id="_Uti6oCL0Eeirb_C4HjtHrA" name="startBehavior" method="_UtlW4CL0Eeirb_C4HjtHrA"/>
        <ownedOperation xmi:id="_UtlW4iL0Eeirb_C4HjtHrA" name="processTE_value_50_unit_ms_" method="_Utl98CL0Eeirb_C4HjtHrA"/>
        <ownedOperation xmi:id="_Utl98SL0Eeirb_C4HjtHrA" name="processTE_value_500_unit_ms_" method="_UtvH4CL0Eeirb_C4HjtHrA"/>
        <ownedOperation xmi:id="_UtvH4SL0Eeirb_C4HjtHrA" name="processCE_CServer_impl_add" method="_UtvH4iL0Eeirb_C4HjtHrA">
          <ownedParameter xmi:id="_Utvu8CL0Eeirb_C4HjtHrA" name="a">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8heigBydEduyofBvg4RL2w"/>
            <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_UtwWACL0Eeirb_C4HjtHrA" value="1"/>
            <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_UtwWASL0Eeirb_C4HjtHrA" value="1"/>
          </ownedParameter>
          <ownedParameter xmi:id="_Utw9ECL0Eeirb_C4HjtHrA" name="b">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8heigBydEduyofBvg4RL2w"/>
            <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_Utw9ESL0Eeirb_C4HjtHrA" value="1"/>
            <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_Utw9EiL0Eeirb_C4HjtHrA" value="1"/>
          </ownedParameter>
        </ownedOperation>
        <ownedOperation xmi:id="_UtxkISL0Eeirb_C4HjtHrA" name="processTE_value_25_unit_ms_" method="_UtyLMCL0Eeirb_C4HjtHrA"/>
        <ownedOperation xmi:id="_UtyLMSL0Eeirb_C4HjtHrA" name="processCompletionEvent" method="_UtyyQCL0Eeirb_C4HjtHrA"/>
        <ownedOperation xmi:id="_UtyyRCL0Eeirb_C4HjtHrA" name="State2_entry" method="_UtzZUCL0Eeirb_C4HjtHrA"/>
        <ownedOperation xmi:id="_UuZPMSL0Eeirb_C4HjtHrA" name="thread_func_wrapper" isStatic="true" method="_UuhyESL0Eeirb_C4HjtHrA">
          <ownedParameter xmi:id="_UuZ2QCL0Eeirb_C4HjtHrA" name="data">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8I6RgBydEduyofBvg4RL2w"/>
          </ownedParameter>
          <ownedParameter xmi:id="_UucSgCL0Eeirb_C4HjtHrA" name="ret" direction="return">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8I6RgBydEduyofBvg4RL2w"/>
          </ownedParameter>
        </ownedOperation>
        <ownedOperation xmi:id="_UunRoSL0Eeirb_C4HjtHrA" name="doCallActivity" method="_UunRoyL0Eeirb_C4HjtHrA">
          <ownedParameter xmi:id="_UunRoiL0Eeirb_C4HjtHrA" name="id">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_7wRIABydEduyofBvg4RL2w"/>
          </ownedParameter>
        </ownedOperation>
        <ownedOperation xmi:id="_Uun4sCL0Eeirb_C4HjtHrA" name="setFlag" method="_Uun4tCL0Eeirb_C4HjtHrA">
          <ownedParameter xmi:id="_Uun4sSL0Eeirb_C4HjtHrA" name="id">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_7wRIABydEduyofBvg4RL2w"/>
          </ownedParameter>
          <ownedParameter xmi:id="_Uun4siL0Eeirb_C4HjtHrA" name="func_type">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_5lVhgBydEduyofBvg4RL2w"/>
          </ownedParameter>
          <ownedParameter xmi:id="_Uun4syL0Eeirb_C4HjtHrA" name="value">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_vAIV4I7PEdySGvm5GN66HA"/>
          </ownedParameter>
        </ownedOperation>
        <ownedOperation xmi:id="_Uu4XYCL0Eeirb_C4HjtHrA" name="listenTimeEvent" method="_Uu4XYyL0Eeirb_C4HjtHrA">
          <ownedParameter xmi:id="_Uu4XYSL0Eeirb_C4HjtHrA" name="id">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_7wRIABydEduyofBvg4RL2w"/>
          </ownedParameter>
          <ownedParameter xmi:id="_Uu4XYiL0Eeirb_C4HjtHrA" name="duration">
            <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_7wRIABydEduyofBvg4RL2w"/>
          </ownedParameter>
        </ownedOperation>
        <ownedOperation xmi:id="_UtAvISL0Eeirb_C4HjtHrA" name="entry_dft"/>
        <ownedOperation xmi:id="_UtAvIiL0Eeirb_C4HjtHrA" name="exit_dft"/>
        <ownedOperation xmi:id="_UtAvIyL0Eeirb_C4HjtHrA" name="doActivity_dft"/>
        <nestedClassifier xmi:type="uml:PrimitiveType" xmi:id="_UtAvJCL0Eeirb_C4HjtHrA" name="State_t"/>
        <nestedClassifier xmi:type="uml:Enumeration" xmi:id="_UtAvICL0Eeirb_C4HjtHrA" name="StateIDEnum">
          <ownedLiteral xmi:id="_UtyyQSL0Eeirb_C4HjtHrA" name="STATE0_ID"/>
          <ownedLiteral xmi:id="_UtyyQiL0Eeirb_C4HjtHrA" name="STATE1_ID"/>
          <ownedLiteral xmi:id="_UtyyQyL0Eeirb_C4HjtHrA" name="STATE2_ID"/>
          <ownedLiteral xmi:id="_UtzZUSL0Eeirb_C4HjtHrA" name="STATE3_ID"/>
          <ownedLiteral xmi:id="_UtzZUiL0Eeirb_C4HjtHrA" name="STATE3_1_ID"/>
          <ownedLiteral xmi:id="_UtzZUyL0Eeirb_C4HjtHrA" name="STATE3_2_ID"/>
          <ownedLiteral xmi:id="_UtzZVCL0Eeirb_C4HjtHrA" name="STATE_MAX"/>
        </nestedClassifier>
        <nestedClassifier xmi:type="uml:PrimitiveType" xmi:id="_UuhyEiL0Eeirb_C4HjtHrA" name="FptPointer"/>
        <nestedClassifier xmi:type="uml:Enumeration" xmi:id="_Us-58CL0Eeirb_C4HjtHrA" name="EventId_t">
          <ownedLiteral xmi:id="_Us_hACL0Eeirb_C4HjtHrA" name="TE_VALUE_50_UNIT_MS__ID"/>
          <ownedLiteral xmi:id="_Us_hASL0Eeirb_C4HjtHrA" name="TE_VALUE_500_UNIT_MS__ID"/>
          <ownedLiteral xmi:id="_Us_hAiL0Eeirb_C4HjtHrA" name="TE_VALUE_25_UNIT_MS__ID"/>
          <ownedLiteral xmi:id="_UtAIECL0Eeirb_C4HjtHrA" name="CE_CSERVER_IMPL_ADD_ID"/>
          <ownedLiteral xmi:id="_UtAIESL0Eeirb_C4HjtHrA" name="COMPLETIONEVENT_ID"/>
        </nestedClassifier>
      </packagedElement>
      <packagedElement xmi:type="uml:Package" xmi:id="_Uu-eASL0Eeirb_C4HjtHrA" name="Interfaces">
        <packagedElement xmi:type="uml:Interface" xmi:id="_cn-H0DLbEd2qeKRLMdIx_A" name="ICompute">
          <ownedReception xmi:id="_1U0U8McqEeSsAI2TZshUyg" name="add" signal="_ywk2kMcqEeSsAI2TZshUyg"/>
          <ownedReception xmi:id="_M-tXYMcrEeSsAI2TZshUyg" name="mult" signal="_z0nGcMcqEeSsAI2TZshUyg"/>
          <ownedOperation xmi:id="_DGs6wDLgEd28fJKJJnUaeQ" name="add">
            <ownedParameter xmi:id="_DGs6wTLgEd28fJKJJnUaeQ" name="a">
              <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8heigBydEduyofBvg4RL2w"/>
              <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_DGs6wzLgEd28fJKJJnUaeQ" value="1"/>
              <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_DGs6wjLgEd28fJKJJnUaeQ" value="1"/>
            </ownedParameter>
            <ownedParameter xmi:id="_DGs6xTLgEd28fJKJJnUaeQ" name="b">
              <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8heigBydEduyofBvg4RL2w"/>
              <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_DGs6xzLgEd28fJKJJnUaeQ" value="1"/>
              <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_DGs6xjLgEd28fJKJJnUaeQ" value="1"/>
            </ownedParameter>
            <ownedParameter xmi:id="_DGs6yTLgEd28fJKJJnUaeQ" name="res" direction="return">
              <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8heigBydEduyofBvg4RL2w"/>
              <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_DGs6yzLgEd28fJKJJnUaeQ" value="1"/>
              <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_DGs6yjLgEd28fJKJJnUaeQ" value="1"/>
            </ownedParameter>
          </ownedOperation>
          <ownedOperation xmi:id="_L8EY8DLgEd28fJKJJnUaeQ" name="mult">
            <ownedParameter xmi:id="_L8EY8TLgEd28fJKJJnUaeQ" name="a">
              <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8heigBydEduyofBvg4RL2w"/>
              <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_L8EY8zLgEd28fJKJJnUaeQ" value="1"/>
              <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_L8EY8jLgEd28fJKJJnUaeQ" value="1"/>
            </ownedParameter>
            <ownedParameter xmi:id="_L8EY9TLgEd28fJKJJnUaeQ" name="b">
              <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8heigBydEduyofBvg4RL2w"/>
              <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_L8EY9zLgEd28fJKJJnUaeQ" value="1"/>
              <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_L8EY9jLgEd28fJKJJnUaeQ" value="1"/>
            </ownedParameter>
            <ownedParameter xmi:id="_L8EY-TLgEd28fJKJJnUaeQ" name="res" direction="return">
              <type xmi:type="uml:PrimitiveType" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/AnsiCLibrary.uml#_8heigBydEduyofBvg4RL2w"/>
              <lowerValue xmi:type="uml:LiteralInteger" xmi:id="_L8EY-zLgEd28fJKJJnUaeQ" value="1"/>
              <upperValue xmi:type="uml:LiteralUnlimitedNatural" xmi:id="_L8EY-jLgEd28fJKJJnUaeQ" value="1"/>
            </ownedParameter>
          </ownedOperation>
        </packagedElement>
        <packagedElement xmi:type="uml:Signal" xmi:id="_ywk2kMcqEeSsAI2TZshUyg" name="Add"/>
        <packagedElement xmi:type="uml:Signal" xmi:id="_z0nGcMcqEeSsAI2TZshUyg" name="Mult"/>
      </packagedElement>
      <packagedElement xmi:type="uml:Dependency" xmi:id="_Uon-YSL0Eeirb_C4HjtHrA" client="_oqZNUDLaEd2qeKRLMdIx_A">
        <supplier xmi:type="uml:Enumeration" href="/ComplexSM_defaultNode_ComplexSMDepPlan/model/statemachine.uml#_hNs5oCdSEea6h5xPEh8iAg"/>
      </packagedElement>
      <packagedElement xmi:type="uml:Dependency" xmi:id="_UtGOsCL0Eeirb_C4HjtHrA" client="_UtAvJCL0Eeirb_C4HjtHrA" supplier="_UtAvICL0Eeirb_C4HjtHrA"/>
      <packagedElement xmi:type="uml:Package" xmi:id="_UvliASL0Eeirb_C4HjtHrA" name="events">
        <packagedElement xmi:type="uml:TimeEvent" xmi:id="_rHoJgOtoEeCjb9i0gG4phA" name="TE - {value=50, unit=ms}" isRelative="true">
          <when xmi:id="_rHoJgetoEeCjb9i0gG4phA">
            <expr xmi:type="uml:OpaqueExpression" xmi:id="_rHoJgutoEeCjb9i0gG4phA">
              <language>Natural language</language>
              <body>{value=50, unit=ms}</body>
            </expr>
          </when>
        </packagedElement>
        <packagedElement xmi:type="uml:TimeEvent" xmi:id="_-PMFcCaeEeG4fZdVXNtoOQ" name="TE - {value=500, unit=ms}" isRelative="true">
          <when xmi:id="_-PMFcSaeEeG4fZdVXNtoOQ">
            <expr xmi:type="uml:OpaqueExpression" xmi:id="_-PMFciaeEeG4fZdVXNtoOQ">
              <language>Natural language</language>
              <body>{value=500, unit=ms}</body>
            </expr>
          </when>
        </packagedElement>
        <packagedElement xmi:type="uml:CallEvent" xmi:id="_8WeCMHoDEeOA64V_YLapaA" name="CE - CServer_impl - add" operation="_TbIjUJYlEd6G9q9hwr11bw"/>
        <packagedElement xmi:type="uml:TimeEvent" xmi:id="_4WSIMCjmEeaJJusTB1aIbg" name="TE - {value=25, unit=ms}" isRelative="true">
          <when xmi:id="_4WSIMSjmEeaJJusTB1aIbg">
            <expr xmi:type="uml:OpaqueExpression" xmi:id="_4WSIMijmEeaJJusTB1aIbg">
              <language>Natural language</language>
              <body>{value=25, unit=ms}</body>
            </expr>
          </when>
        </packagedElement>
      </packagedElement>
    </packagedElement>
    <profileApplication xmi:id="_O6TiIjLUEd26WNosUASSSw">
      <eAnnotations xmi:id="_O6TiIzLUEd26WNosUASSSw" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/uml2/5.0.0/UML/Profile/Standard#/"/>
      </eAnnotations>
      <appliedProfile href="pathmap://UML_PROFILES/Standard.profile.uml#_0"/>
    </profileApplication>
    <profileApplication xmi:id="_GcC0cAHtEd6HSdiss9GQ0A">
      <eAnnotations xmi:id="_Gd1kMAHtEd6HSdiss9GQ0A" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/C_Cpp/1#/"/>
      </eAnnotations>
      <appliedProfile href="pathmap://PapyrusC_Cpp_PROFILES/C_Cpp.profile.uml#_j9REUByGEduN1bTiWJ0lyw"/>
    </profileApplication>
    <profileApplication xmi:id="_zi-sUE2sEeGl8qrc8BM7vA">
      <eAnnotations xmi:id="_0QJUUE2sEeGl8qrc8BM7vA" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/MARTE/1#//MARTE_Foundations/Alloc"/>
      </eAnnotations>
      <appliedProfile href="pathmap://Papyrus_PROFILES/MARTE.profile.uml#_ar8OsAPMEdyuUt-4qHuVvQ"/>
    </profileApplication>
    <profileApplication xmi:id="_Uon-YiL0Eeirb_C4HjtHrA">
      <eAnnotations xmi:id="_Uon-YyL0Eeirb_C4HjtHrA" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/uml2/5.0.0/UML/Profile/Standard#/"/>
      </eAnnotations>
      <appliedProfile href="pathmap://UML_PROFILES/Standard.profile.uml#_0"/>
    </profileApplication>
  </uml:Model>
  <Deployment:DeploymentPlan xmi:id="_Uu928CL0Eeirb_C4HjtHrA" base_Package="_Uu9P4iL0Eeirb_C4HjtHrA"/>
  <C_Cpp:Include xmi:id="_Uu-eACL0Eeirb_C4HjtHrA" body="#include &lt;iostream>&#xA;using namespace std;&#xA;&#xA;#include &lt;unistd.h>&#xA;" header="#define COMPLEXSM_TIME_EVENT_LOWER_BOUND (0)&#xA;#define COMPLEXSM_CHANGE_EVENT_LOWER_BOUND (3)&#xA;#define COMPLEXSM_TE_INDEX(id) (id - COMPLEXSM_TIME_EVENT_LOWER_BOUND)&#xA;#define COMPLEXSM_CHE_INDEX(id) (id - COMPLEXSM_CHANGE_EVENT_LOWER_BOUND)&#xA;#define SMSIMPLE_REGION0_DEFAULT (0)&#xA;#define SMSIMPLE_REGION0_STATE1 (1)&#xA;#define STATE3_REGION1_SHALLOWHISTORY1 (1)&#xA;#define SMSIMPLE_REGION0 (0)&#xA;#define STATE3_REGION1 (1)&#xA;#include &quot;time.h&quot;&#xA;#include &quot;pthread.h&quot;&#xA;#include &quot;time.h&quot;&#xA;&#x9;&#x9;#include &quot;sys/time.h&quot;&#xA;#define CHECKPOINT if (systemState == statemachine::EVENT_PROCESSING) {return;}&#xA;#define ComplexSM_THREAD_CREATE(thThread, str) pthread_create(&amp;thThread, NULL, &amp;ComplexSM::thread_func_wrapper, &amp;str);&#xA;#define COMPLEXSM_GET_CONTROL /*mutex synchronization to protect run-to-completion semantics*/ \&#xA;&#x9;&#x9;pthread_mutex_lock(&amp;runToCompletionMutex); \&#xA;&#x9;&#x9;while (systemState != statemachine::IDLE) {\&#xA;&#x9;&#x9;&#x9;pthread_cond_wait(&amp;runToCompletionCond, &amp;runToCompletionMutex);\&#xA;&#x9;&#x9;}&#xA;#define COMPLEXSM_RELEASE_CONTROL systemState = statemachine::IDLE; pthread_cond_signal(&amp;runToCompletionCond); \&#xA;&#x9;&#x9;&#x9;&#x9;pthread_mutex_unlock(&amp;runToCompletionMutex);" base_class="_oqZNUDLaEd2qeKRLMdIx_A"/>
  <C_Cpp:Typedef xmi:id="_UvO8sCL0Eeirb_C4HjtHrA" definition="struct State_t {&#xA;&#x9;//1 is configured as the maximum number of orthogonal regions a composite states can have&#xA;&#x9;unsigned int /*StateIDEnum*/ previousStates[1]; //for history states&#xA;&#x9;unsigned int /*StateIDEnum*/ actives[1];&#xA;&#x9;void (ComplexSM::*entry)();&#xA;&#x9;void (ComplexSM::*exit)();&#xA;&#x9;void (ComplexSM::*doActivity)();&#xA;&#x9;State_t() {&#xA;&#x9;&#x9;entry = &amp;ComplexSM::entry_dft;&#xA;&#x9;&#x9;exit = &amp;ComplexSM::exit_dft;&#xA;&#x9;&#x9;doActivity = &amp;ComplexSM::doActivity_dft;&#xA;&#x9;&#x9;for(int i = 0; i &lt; 1; i++) {&#xA;&#x9;&#x9;&#x9;previousStates[i] = STATE_MAX;&#xA;&#x9;&#x9;&#x9;actives[i] = STATE_MAX;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;} " base_primitivetype="_UtAvJCL0Eeirb_C4HjtHrA"/>
  <C_Cpp:Array xmi:id="_UvO8sSL0Eeirb_C4HjtHrA" definition="[6]" base_property="_UtG1wCL0Eeirb_C4HjtHrA"/>
  <C_Cpp:Array xmi:id="_UvQx4SL0Eeirb_C4HjtHrA" definition="[STATE_MAX]" base_property="_Ut0AYCL0Eeirb_C4HjtHrA"/>
  <C_Cpp:Array xmi:id="_UvRY8CL0Eeirb_C4HjtHrA" definition="[STATE_MAX]" base_property="_Ut78MSL0Eeirb_C4HjtHrA"/>
  <C_Cpp:Array xmi:id="_UvSAACL0Eeirb_C4HjtHrA" definition="[STATE_MAX]" base_property="_UuGUQSL0Eeirb_C4HjtHrA"/>
  <C_Cpp:Array xmi:id="_UvSnECL0Eeirb_C4HjtHrA" definition="[STATE_MAX]" base_property="_UuLz0SL0Eeirb_C4HjtHrA"/>
  <C_Cpp:Array xmi:id="_UvXfkyL0Eeirb_C4HjtHrA" definition="[STATE_MAX]" base_property="_UuShgSL0Eeirb_C4HjtHrA"/>
  <C_Cpp:Typedef xmi:id="_UvYGoCL0Eeirb_C4HjtHrA" definition="void (ComplexSM::*typeName)()" base_primitivetype="_UuhyEiL0Eeirb_C4HjtHrA"/>
  <C_Cpp:Array xmi:id="_UvYGoSL0Eeirb_C4HjtHrA" definition="[STATE_MAX]" base_property="_Uuk1YCL0Eeirb_C4HjtHrA"/>
  <C_Cpp:Array xmi:id="_UvYtsCL0Eeirb_C4HjtHrA" definition="[3]" base_property="_UuofwCL0Eeirb_C4HjtHrA"/>
  <C_Cpp:Array xmi:id="_UvYtsiL0Eeirb_C4HjtHrA" definition="[3]" base_property="_Uuq8ASL0Eeirb_C4HjtHrA"/>
  <C_Cpp:Array xmi:id="_UvZUwCL0Eeirb_C4HjtHrA" definition="[3]" base_property="_UutYQSL0Eeirb_C4HjtHrA"/>
  <C_Cpp:Array xmi:id="_UvZUwiL0Eeirb_C4HjtHrA" definition="[3]" base_property="_Uuv0gSL0Eeirb_C4HjtHrA"/>
  <C_Cpp:Array xmi:id="_UvZUxCL0Eeirb_C4HjtHrA" definition="[3]" base_property="_Uuy30SL0Eeirb_C4HjtHrA"/>
  <C_Cpp:Array xmi:id="_UvZ70CL0Eeirb_C4HjtHrA" definition="[3]" base_property="_Uu1UESL0Eeirb_C4HjtHrA"/>
  <C_Cpp:Ptr xmi:id="_UvjFwSL0Eeirb_C4HjtHrA" base_property="_Uu4-cCL0Eeirb_C4HjtHrA"/>
  <standard:Create xmi:id="_Uv2AsCL0Eeirb_C4HjtHrA" base_BehavioralFeature="_UtYikCL0Eeirb_C4HjtHrA"/>
  <C_Cpp:Ptr xmi:id="_Uv65MiL0Eeirb_C4HjtHrA" base_parameter="_UuZ2QCL0Eeirb_C4HjtHrA"/>
  <C_Cpp:Ptr xmi:id="_Uv7gQSL0Eeirb_C4HjtHrA" base_parameter="_UucSgCL0Eeirb_C4HjtHrA"/>
</xmi:XMI>
